<script>
    import ArrowDown from 'components/Icons/ArrowDown.svelte'
    import ArrowUp from 'components/Icons/ArrowUp.svelte'
    import Spinner from 'components/Icons/Spinner.svelte'
    import { awaitingAPI } from 'store'

    export let callback

    let container
    let firstPosY
    let offset
    let dragging = true

    const totalHeight = 77
    const transitionDuration = 150

    const resetProperties = _ => {
        setTimeout(_ => {
            container.style.transition = 'none'
            firstPosY = undefined
            offset = totalHeight
        }, transitionDuration)
    }

    const handleTouchEnd = async _ => {
        dragging = false
        container.style.cursor = 'auto'

        if (offset !== undefined && offset < totalHeight) {
            container.style.transition = `margin ${transitionDuration}ms ease-out`

            if (offset === 0) {
                container.style.marginTop = `-8px`

                await callback()
                container.scrollTop = 0
            }

            container.style.marginTop = 'var(--marginTop)'
            resetProperties()
        }
    }

    const handleTouchMove = e => {
        dragging = true

        if (container.parentNode.scrollTop === 0) {
            if (firstPosY === undefined) {
                firstPosY = e.touches[0].clientY
            }
            offset = totalHeight - (e.touches[0].clientY - firstPosY)
            if (offset < 0) offset = 0
            container.style.marginTop = `-${offset}px`
            container.style.cursor = 'grabbing'
        }
    }
</script>

<div
    style="--marginTop: -{totalHeight}px; --height: {totalHeight}px"
    on:touchmove={handleTouchMove}
    on:touchend={handleTouchEnd}
    bind:this={container}
>
    <span id="ptr-loader">
        {#if $awaitingAPI}
            <Spinner />
        {:else if dragging}
            <ArrowDown />
        {:else}
            <ArrowUp />
        {/if}
    </span>
    <slot />
</div>

<style lang="postcss">
    div {
        margin-top: var(--marginTop);

        #ptr-loader {
            @apply relative flex items-center justify-center bg-teal-200 w-full pt-2 text-teal-600 text-opacity-50 z-0;
            height: var(--height);
        }
    }
</style>
